/* Copyright (c) 2019 The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *     * Neither the name of The Linux Foundation nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#ifndef __CAMERA1_INTERFACE_H__
#define __CAMERA1_INTERFACE_H__

#include "Camera1Common.h"
#include "VideoEncoderInterface.h"

#ifndef DISALLOW_COPY_AND_ASSIGN
#define DISALLOW_COPY_AND_ASSIGN(TypeName) \
  TypeName(const TypeName&);               \
  void operator=(const TypeName&)
#endif

#define TEN_YEARS_NS    (10 * 365 * 24 * 3600 * 1000000000LL)
#define BOOTTIME_TYPE   0
#define SYSTEMTIME_TYPE 1

namespace camera1_if
{
/**
 * Interface for camera callbacks object. Client needs to
 * implement this interface to get access to camera data and
 * control events. The methods in listener can be invoked from
 * multiple different threads. Client needs to make sure that
 * implementation is thread-safe.
 */
class Camera1Callbacks : public CameraListener
{
public:
    virtual ~Camera1Callbacks() {};

    /* Implementation of virtual methods of CameraListener interface */
    void Init(int timetype = SYSTEMTIME_TYPE);
    void dumpFrameToFile(char* fname, CameraFrame frame);
    virtual void notify(int32_t msgType, int32_t ext1, int32_t ext2);
    virtual void postData(int32_t msgType, const sp<IMemory>& dataPtr,
                          camera_frame_metadata_t *metadata);
    virtual void postDataTimestamp(nsecs_t timestamp,
                          int32_t msgType, const sp<IMemory>& dataPtr);


    Mutex        mLock;
    Condition    mCbMonitorSignal;
    Condition    mPictureSignal;

protected:
    int          mCamId;

private:
    /**
     * This function is called when an error is generated by camera
     * driver
     */
    virtual void onError();

    /**
     * This function is called when a preview frame is generated by
     * camera.
     *
     * @param frame [in]: Camera1Frame struct to store frame info
     */
    virtual void onPreviewFrame(CameraFrame frame) = 0;

    /**
     * This function is called when a preview frame is generated by
     * camera.
     *
     * @param frame [in]: Camera1Frame struct to store frame info
     */
    virtual void onVideoFrame(CameraFrame frame) = 0;

    /**
     * This function is called when a snapshot frame is generated by
     * camera.
     *
     * @param frame [in]: Camera1Frame struct to store frame info
     */
    virtual void onPictureFrame(CameraFrame frame) = 0;

    /**
     * This function is called when a metadata frame is generated by
     * camera.
     *
     * @param frame [in]: Camera1Frame struct to store frame info
     */
    virtual void onMetadataFrame(CameraFrame frame) {};

    /**
     * This function is called when a raw frame is generated by
     * camera.
     *
     * @param frame [in]: Camera1Frame struct to store frame info
     */
    virtual void onRawFrame(CameraFrame frame) {};

    /**
     * This function is called for getting Video Encoder instance
     *
     */
    virtual VideoEncoderInterface* getVideoEncoderIF()
    {
        return NULL;
    }

    /**
     * This function is called to get the CLOCK_BOOTTIME time
     */
    uint64_t GetBootTime()
    {
        struct timespec t;
        t.tv_sec = t.tv_nsec = 0;
        clock_gettime(CLOCK_BOOTTIME, &t);
        return nsecs_t(t.tv_sec)*1000000000LL + t.tv_nsec;
    }

    /**
     * This function is called to get the CLOCK_REALTIME time
     */
    uint64_t GetSystemTime()
    {
        return systemTime();
    }

    bool IsSystemtime(uint64_t time)
    {
        if (time > TEN_YEARS_NS)
            return true;
        else
            return false;
    }

    uint64_t  mLastFeedTime;
    uint64_t  mBootTimestamp;
    uint64_t  mSystemTimestamp;
    uint64_t  mTimestampOffset;
};

/**
 * Interface to Camera1Params.
 * Please refer to class CameraParameters.
 */
class Camera1Params : public CameraParameters
{
public:
    Camera1Params() {}
    ~Camera1Params() {}
    Vector<string> getStringV(const char *key) const;
    Vector<int> getIntV(const char *key) const;
    void setString(const char *key, string value);
    string getString(const char *key) const;
    void setPreviewFpsRange(int min_fps, int max_fps);
    Vector<Range> getSupportedPreviewFpsRanges() const;
private:
    static Vector<string> parseCSV(const char *valueStr);
    static Vector<int> parseCIV(const char *valueStr);
    static Vector<string> parseParanthesis(const char *valueStr);
};

/**
 * Interface to camera client.
 */
class Camera1Interface
{
    DISALLOW_COPY_AND_ASSIGN(Camera1Interface);
protected:
    Camera1Interface(int cameraId);
    virtual ~Camera1Interface() {}
    int StartCbMonitor();
    void StopCbMonitor();
    static void* CbMonitorThread(void* data);
    void CreateVideoEncoder(VideoConfig config);
    void ReleaseVideoEncoder();

protected:
    enum Camera1Status {
        CAMERA1STATUS_INVALID = 0,
        CAMERA1STATUS_INITED  = 1,
    };

    int                       mCameraId;
    Camera1Status             mStatus;
    Camera1Callbacks         *mCb;
    VideoEncoderInterface    *mVideoEncoderIF;
    static const nsecs_t      kTimeout = 10e9;
private:
    PthreadInfo               mCbMonitorThread;
    bool                      mIsMonitoring;

public:
    enum Camera1BridgeMode {
        MODE_LEGACY = 0,
        MODE_QMMF   = 1,
        MODE_FWI    = 2,
    };
    Camera1BridgeMode                   mBridgeMode;
    Camera1Params                       mParams;

public:
    /**
    * Get the number of camera (sensors) detected on the device.
    *
    * @return int
    **/
    static int getNumberOfCameras(Camera1BridgeMode mode);

    /**
     * Get the additional information about camera by index. index 0 identifies
     * the first camera.
     *
     * @param idx : index of the camera device. index 0 identifies first
     *            camera.
     * @param info
     * @return int : 0 is success
     **/
    static int getCameraInfo(Camera1BridgeMode mode, int cameraId, struct CameraInfo& cameraInfo);

    /**
     * Factory method to create an instance of Camera1Interface
     *
     * @param camId         [in]: camera ID
     * @param binderEnable  [in]: whether use binder
     * @param device        [out]: pointer to to a Camera1Interface* to be created
     *
     * @return int : 0 on Success
     */
    static int createInstance(Camera1BridgeMode mode, int camId, Camera1Interface** cameraIF);

    /**
     * delete instance of an Camera1Interface
     *
     * @param device [out]: pointer to an Camera1Interface* to be
     *               deleted
     */
    static void deleteInstance(Camera1Interface** cameraIF);

    /**
     * Add listener to handle various notifications and data frames from the
     * camera device.
     * @param listener [in]
     **/
    virtual int setCallbacks(Camera1Callbacks *cb);

public:
    /**
     * Start preview stream on camera
     *
     * @return int : 0 on success
     */
    virtual int startPreview() = 0;

    /**
     * Stop preview streaming
     */
    virtual int stopPreview() = 0;

    /**
     * @brief Take a picture
     *
     * Preview needs to be running when this method is called. Video
     * recording may or may not be running. If successful,
     * onPictureFrame() callback is called with image data for
     * picture. Client needs to wait for this callback before taking
     * any more pictures.
     *
     * @return int
     */
    virtual int takePicture(bool zsl) = 0;

    /**
     * Start video recording stream
     *
     * @return int : 0 on success
     */
    virtual int startRecording(VideoConfig videoConfig) = 0;

    /**
     * Stop video recording
     */
    virtual int stopRecording() = 0;

    /** 
     * Gets the pointer to the the class object that define the 
     * parameters of the camera sensor.
     *  
     * @return pointer to parameters object typecasted to void 
     **/
    virtual const Camera1Params getParameters() = 0; 

    /**
     * Subscribe for camera control events
     *
     * @param eventMask : is a bitmask of values in enum EventType
     * @return int : 0 on success
     **/
    virtual int setParameters(Camera1Params& params) = 0;

public:
    /**
     * Transfer recoding input frames to OMX for encoder
     * @param frame [in]
     **/
    void GenerateVideoByFrame(CameraFrame frame);

    /**
     * Notify service/hal to process error events
     **/
    virtual int ErrorNotify()
    {
        CAM_ERR("raise error");
        raise(SIGSEGV);
        return NO_ERROR;
    }
};

} /* namespace camera */

#endif  /* !__CAMERA_H__ */
